<?php
// block.php
// created the 21/03/06 by mickael ROYER

/*
 * functions used to construct the html page
*/

function ajax_header() {
  $output = '<script type="text/javascript" src="javascript/browser.js"></script>'."\n";
  $output .= '<script type="text/javascript" src="javascript/ajax.js"></script>'."\n";
  $output .= '<script type="text/javascript" src="javascript/common.js"></script>'."\n";
  $output .= '<script type="text/javascript" src="javascript/layer.js"></script>'."\n";
  $output .= '<script type="text/javascript" src="javascript/main.js"></script>'."\n";
  
  return $output;
}

function playlist()
{
	return '<table>
		<thead><tr><td>'.t('Title').'</td>
		<td>'.t('Artist').'</td>
		<td>'.t('Album').'</td>
		<td>'.t('Time').'</td></tr>
		</thead><tbody id="playlist_content">
		</tbody></table>'."\n";
}

function playlist_extra() 
{
	$output = '<div id="mode_command">'."\n";
	$output .= l(t('Random'),'command.php?action=random',true,'random');
	$output .= l(t('Repeat'),'command.php?action=repeat',true,'repeat');
	$output .= '</div>'."\n";

	$output .= '<div id="playlist_command">'."\n";
	$output .= '<a id="pl-shuffle_command">'.t('Shuffle')."</a>\n";
	$output .= '<a id="pl-save_command">'.t('Save')."</a>\n";
	$output .= '<a id="pl-clear_command">'.t('Clear All')."</a>\n";
	$output .= '<a id="pl-clearsel_command">'.t('Clear Selected')."</a>\n";
	$output .= '</div>'."\n";

	return $output;
}

function save_playlist_block()
{
	require_once('./include/cls/form.php');
	$form = new form();

	$item = $form->field('playlist_name',25,50);
	$output = $form->create_item(t('Enter the playlist name :'),$item);
	$output .= $form->button(t('Save'),'return ajaxmp_ref.save_playlist(this);');
	$output .= $form->button(t('Cancel'),'return ajaxmp_ref.cancel_save_playlist();');

	$output = $form->create_form($output);

	return $output;
}

function webradios_playlist()
{
	return '<table>
		<thead><tr><td>'.t('Webradios url').'</td>
		</thead><tbody id="playlist_content">
		</tbody></table>'."\n";
}

function webradios_playlist_extra()
{
	$output = '<div id="webradios_command">'."\n";
	$output .= '<a id="plweb-erase_command">'.t('Erase all Webradios')."</a>\n";
	$output .= '<a id="plweb-erasesel_command">'.t('Erase selected Webradios')."</a>\n";
	$output .= '</div>'."\n";

	return $output;
}

function command_block()
{
	$output = '<div id="command" class="command">'."\n";
	$output .= "<table>\n";

	$output .= "<tr><td>";
	// command part
	$commands = array('previous', 'play', 'pause', 'stop', 'next');
	foreach ($commands as $command) 
		$output .= l('<img name="'.$command.'" src="./images/'.$command.'.png">','./command.php?action='.$command);

	// Volume and time part
	$output .= '<ul class="menu">';

	$output .= '<li><a href="" id="volume_id" 
			onClick="ajaxmp_ref.setbar(this,\'volume\'); return false;">'.
			t('Volume').'</a></li>';

	$output .= '<li><a href="" id="time_id"
			onClick="ajaxmp_ref.setbar(this,\'time\'); return false;">'.
			t('Time').'</a></li>';

	$output .= '</ul>';

	//construc the control bar
	$output .= '<div id="bar" style="display: none">'; 

	$output .= '<form name="bar_form">'."\n";
	$output .= '<input class="form-submit" type="submit" value="-" 
			onclick="ajaxmp_ref.down_valuebar(); return false;"/>';

	for ($i=1;$i<101;$i++) 
		$output .= '<input type="image" id="bar-'.$i.'" src="images/sliderdark.png" 
				onclick="ajaxmp_ref.set_valuebar(\''.$i.'\'); return false;"/>';

	$output .= '<input class="form-submit" type="submit" value="+" 
			onclick="ajaxmp_ref.up_valuebar(); return false;"/>';
	$output .= "</form>\n";

	$output .= '</div>';// END bar 

	$output .= '</td></tr>';
	$output .= "</table>\n";
	$output .= "</div>\n";// END command

	return $output;
}

function current_track()
{
	// current track part
	$output = '<div class="current_track" id="current_track"></div>'."\n";


	return $output;
}

function navigation_block() 
{
	// Menu
	$output = '<div id="nav_menu" class="menu">'."\n";
	$output .= '<a href="" id="library_menu" onClick="return ajaxmp_ref.nav_library(\'\');">'.t('Library').'</a>';
	$output .= '<a href="" id="search_menu" onClick="return ajaxmp_ref.nav_search();">'.t('Search').'</a>';
	$output .= '<a href="" id="webradios_menu" onClick="return ajaxmp_ref.nav_webradios();">'.t('Webradios').'</a>';
	$output .= '<a href="" id="config_menu" onClick="return ajaxmp_ref.nav_config();">'.t('Configuration').'</a>';
	$output .= "</div>\n";

	$output .= '<div id="library_submenu" style="display: none;">'."\n";
	$output .= '<a href="" id="directory_menu" onClick="return ajaxmp_ref.nav_library(\'directory\');">'.t('Files System').'</a>';
	$output .= '<a href="" id="tag_menu" onClick="return ajaxmp_ref.nav_library(\'tag\');">'.t('Tag').'</a>';
	$output .= '<a href="" id="playlist_menu" onClick="return ajaxmp_ref.nav_library(\'playlist\');">'.t('Playlist').'</a>';
	$output .= "</div>\n";

	// Search form
	$output .= search_block();

        // Add a webradio form
        $output .= addwebradio_block();

	// Main content
	$output .= '<div id="navigation_content" class="content">'."\n";
	$output .= "</div>\n";

	return $output;
}

function file_select_block()
{
	$output = '<div id="select_file_menu">'."\n";
	$output .= t('Select : ');
	$output .= '<a href="" id="select_file_all" onclick="return false;">'. t('All').'</a>';
	$output .= '<a href="" id="select_file_none" onclick="return false;">'.t('None').'</a>';
	$output .= '<a href="" id="select_file_invert" onclick="return false;">'.t('Invert').'</a>';
	$output .= "</div>\n";

	return $output;
}

function file_action_block()
{
	$output = '<div id="file_action_menu">'."\n";

	$output .= '<a id="file-load_command">'.t('Load')."</a>\n";
	$output .= '<a id="file-erase_command">'.t('Erase')."</a>\n";

	$output .= "</div>\n";
	return $output;
}

function search_block() {
	require_once('./include/cls/form.php');

	$output = '<div id="search_form" style="display: none;">'."\n";

	$search_type = array("filename" => t("Filename"),"album" => t("Album"),"artist" => t("Artist"),"title" => t("Title"));
	$form = new form();

	$item = $form->field('search_string',25,50);
	$item .= $form->select('search_type','artist',$search_type);
	$item .= $form->button(t('Clear'),'return ajaxmp_ref.clear_search(this.parentNode);');

	$output .= $form->create_form($item,'search_form_name');

	$output .= "</div>\n";

	return $output;
}

function addwebradio_block() {
        require_once('./include/cls/form.php');

        $output = '<div id="addwebradio_form" style="display: none;">'."\n";

        $form = new form();

        $item = $form->field('webradio_url',50,256,NULL,NULL);
        $group = $form->create_item(t('Webradio URL'),$item);
        $group .= $form->button(t('Add webradio'),'return ajaxmp_ref.add_webradio(this.parentNode);');

        $output .= $form->create_form($group);

        $output .= "</div>\n";

        return $output;
}

function config_block($xfade)
{
	global $config;
	global $auth_config;
	require_once('./include/cls/form.php');

	$form = new form();
	// Database update part
	$item = $form->submit(t('Update'),'command.php?action=update');
	$output = collapsible_fieldset(t('Update the database'),$form->create_form($item),true);

	// Xfade part
	$item = $form->field('xfade',2,2,$xfade);
	$item .= $form->button(t('Update'),'return ajaxmp_ref.set_xfade(this);');
	$output .= collapsible_fieldset(t('Xfade'),$form->create_form($item),true);

	// Interface configuration part
	// Only if we can modify these parameters
	if (isset($auth_config))
	{
		$item = $form->checkbox(t('Enable Shortcut keys'),'enable_shortcut_keys',true,
				$config->variable_get('enable_shortcut_keys'));
		$group = $form->create_item(t('Shortcut Keys :'),$item);

		$item = $form->field('dbl_click',3,3,$config->variable_get('dbl_click'));
		$group .= $form->create_item(t('Double click timer (ms) :'),$item);

		$item = $form->field('message_time',4,4,$config->variable_get('message_time'));
		$group .= $form->create_item(t('Message timer (ms) :'),$item);

		$item = $form->field('request_timeout',5,5,$config->variable_get('request_timeout'));
		$group .= $form->create_item(t('HTTP request timeout (ms) :'),$item);

		$item = $form->field('refresh',2,2,$config->variable_get('refresh'));
		$group .= $form->create_item(t('Refresh Time (sec) :'),$item);

		$item = $form->select('lang',$config->variable_get('lang'),list_lang());
		$group .= $form->create_item(t('Language :'),$item);

		$item = $form->select('theme',$config->variable_get('theme'),list_theme());
		$group .= $form->create_item(t('Theme :'),$item);

		$item = $form->select('default_library',$config->variable_get('default_library'),
				array('tag' => t('Tag'),'directory' => t('Directory'),'playlist' => t('Playlist')));
		$group .= $form->create_item(t('Default library view :'),$item);

		$group .= $form->button(t('Update'),'return ajaxmp_ref.send_config(this.parentNode);');
		$output .= collapsible_fieldset(t('User configuration'),$form->create_form($group,'config_form'),false);
	}

	return $output;
}

function list_theme()
{
	$res = array();
	if (($dh = @opendir('./themes')) !== false)
	{
		while (($f = readdir($dh)) !== false) 
		{
			if ($f == '.' || $f == '..' || !is_readable('./themes/'.$f.'/template.php'))
				continue;

			$res[$f] = $f;
		}
		closedir($dh);

		return $res;
	}
	else
		return false;
}

function list_lang()
{
	$res = array();
	$res['en'] = 'en';
	
	if (($dh = @opendir('./l10n')) !== false)
	{
		while (($f = readdir($dh)) !== false) 
		{
			if ($f == '.' || $f == '..' || $f == 'extractor.php')
				continue;

			$lang = explode('.php',$f);
			$res[$lang[0]] = $lang[0];
		}
		closedir($dh);

	}

	return $res;
}

function login_block() 
{
	$output = '';
	if (isset($_SESSION['sess_user_id'])) 
	{
		$output .= '<div class="login" id="login">'."\n";
		$output .= t('Logged as'). '<strong> ' . $_SESSION['sess_user_id'] . '</strong>';
		$output .= '<a href="?action=logout">'.t('Logout').'</a>'; 
		$output .= "</div>\n";
	}

	return $output;
}
?>
