<?php
// class.auth.php
// created by mickael ROYER

class auth
{
	var $failed_redirect;
	var $users_array;
	
	function auth($users,$failed_redirect='login.php')
	{
		$this->failed_redirect = $failed_redirect;
		$this->users_array = $users;
	}
	
	function check()
	{
		$failed = true;
		
		if (empty($_SESSION['sess_user_id']))
		{
			if (!empty($_COOKIE['ajaxmp_user']) && !empty($_COOKIE['ajaxmp_pwd']))
			{
				$user = $_COOKIE['ajaxmp_user'];
				$pwd = $_COOKIE['ajaxmp_pwd'];
				
				$failed = !$this->perform($user,
							$pwd);

				if (!$failed) {
					$_SESSION['sess_user_id'] = $user;
				}
			}
			else
			{
				$failed = true;
			}
		}
		else
		{
			$failed = false;
		}
		
		if ($failed) {
			header('Location: '.$this->failed_redirect);
			exit;
		}
	}
	
	function perform($user_id,$user_pwd,$user_remember = false)
	{
		
		$res = false;
		if($this->checkUser($user_id,$user_pwd))
		{
			if ($user_remember)
			{
				# Create a cookie (15 days)
				$cookie_ttl = strtotime('+15 days');
				setcookie('ajaxmp_user',$user_id,$cookie_ttl);
				setcookie('ajaxmp_pwd',$user_pwd,$cookie_ttl);
			}
			
			$res = true;
		}
		
		return $res;
	}

	function checkUser($user_id,$user_pwd)
	{
		$res = false;
		if (is_array($this->users_array)) 
		{
			if (array_key_exists($user_id, $this->users_array) && ($this->users_array[$user_id] == $user_pwd))
				$res = true;
		}

		return $res;
	}
	
}

class auth_file extends auth {

	var $files_path;

	function auth_file($files_path,$failed_redirect='login.php') 
	{
		$this->failed_redirect = $failed_redirect;
		$this->files_path = $files_path;
	}

	function checkUser($user_id,$user_pwd)
	{
		$res = false;
		$users = file($this->files_path);
		
		foreach ($users as $num => $user) 
		{
			// skip comments
			if (strpos($user,"#") === '0')
				continue;

			$user = explode("\t",rtrim($user));
		
			if ($user['0'] == $user_id && $user['1'] == $user_pwd)
			{
				$res = true;
				break;
			}
		}

		return $res;
	}

}
?>
