<?php

class form
{

	function create_form($form,$name='',$method = 'post')
	{
		$res = '<form ';
		$res .= ($name != '' ? 'name="'.$name.'" id="'.$name.'" ' : '');
		$res .= 'method="'.$method.'" >'."\n"; 
		$res .= $form."</form>\n";
		return $res;	
	}

	function create_item($title,$element,$description=NULL)
	{
		$res = '<div class="form-item">'."\n";
		$res .= ($title == '' ? '' : '<label class="form-title">'.$title.'</label>');
		$res .= '<br/>'.$element;
		$res .= ($description ? '<div class="description">'.$description.'</div>' : '');
		$res .= "</div>\n";
		return $res;
	}

	function select($name,$value,$options,$multiple = FALSE,$onclick =NULL)
	{
		$select = '';
		foreach ($options as $key => $choice) {
		  if (is_array($choice)) {
		    $select .= '<optgroup label="'. $key .'">';
		    foreach ($choice as $key => $choice) {
		      $select .= '<option value="'. $key .'"'. 
		      	(is_array($value) ? (in_array($key, $value) ? ' selected="selected"' : '') : ($value == $key ? ' selected="selected"' : '')) .
			($onclick ? ' onClick="'.$onclick.'"' : '').
			'>'. check_plain($choice) .'</option>';
		      }
		    $select .= '</optgroup>';
		    }
		  else {
		    $select .= '<option value="'. $key .'"'. 
		    	(is_array($value) ? (in_array($key, $value) ? ' selected="selected"' : '') : ($value == $key ? ' selected="selected"' : '')) .
			($onclick ? ' onClick="'.$onclick.'"' : '').
			'>'. check_plain($choice) .'</option>';
		    }
		  }
		return '<select name="'. $name . ($multiple ? '[]' : '') .'"'. ($multiple ? ' multiple="multiple" ' : '') . ' id="'. $name .'">'. $select .'</select>';
	}
	
	function radio($title,$name, $value, $checked=FALSE, $attributes=NULL)
	{
		$res = '<input type="radio" class="form-radio" name="'. $name .'" id="edit-'. $name .'" value="'. check_plain($value) .'"'. ($checked ? ' checked="checked"' : '') . set_attributes($attributes) .' />';

		if (!is_null($title))
		  $res = '<label class="option">'. $res .' '. $title .'</label>';

		return $res;
	}

	function checkbox($title,$name,$value,$checked=FALSE,$attributes = NULL)
	{
		$res = '<input type="checkbox" class="form-checkbox" name="'. $name .'" id="'. $name .'" value="'. check_plain($value) .'"'. ($checked ? ' checked="checked"' : '') . set_attributes($attributes) .' />';

		if (!is_null($title))
		  $res = '<label class="option">'. $res .' '. $title .'</label><br/>';

		return $res;
	}

	function field($name,$size,$max='',$default='',$attributes=NULL)
	{
		$res = '<input type="text" size="'.$size.'" name="'.$name.'" ';
		
		$res .= 'id="'.$name.'" ';		
		$res .= ($max != '') ? 'maxlength="'.$max.'" ' : '';
		$res .= ($default != '') ? 'value="'.check_plain($default).'" ' : '';
		$res .= set_attributes($attributes);
		
		$res .= ' />';
		
		return $res;
	}
	
	function password($name,$size,$max='',$default='',$attributes=NULL)
	{
		$res = '<input type="password" size="'.$size.'" name="'.$name.'" ';
		
		$res .= 'id="'.$name.'" ';		
		$res .= ($max != '') ? 'maxlength="'.$max.'" ' : '';
		$res .= ($default != '') ? 'value="'.check_plain($default).'" ' : '';
		$res .= set_attributes($attributes);
		
		$res .= ' />';
		
		return $res;
	}

	function textarea($name,$rows,$cols=NULL,$default='',$attributes= NULL,$tabindex='')
	{
		$res = '<textarea rows="'.$rows.'" ';
		$res .= ($cols) ? 'cols="'.$cols.'" ' : '';
		$res .= 'name="'.$name.'" id="edit-'.$name.'" ';
		$res .= ($tabindex != '') ? 'tabindex="'.$tabindex.'" ' : '';
		$res .= set_attributes($attributes).'>';
		$res .= $default;
		$res .= '</textarea>';
		
		return $res;
	}
	
	function hidden($name,$value)
	{
		return '<input type="hidden" name="'.$name.'" value="'.check_plain($value).'" />';
	}

	function submit($value, $onclick = NULL, $form = NULL, $name = 'op',$attributes = NULL)
	{
		$output = '<input type="submit" name="'.$name.'" class="form-submit" value="'.$value.'" ';
		
		if ($onclick)
		{
			if ($form)
				$output .= 'onClick="ajaxmp_ref.send_http_request(\'POST\',\''.$onclick.'\','.$form.',true);return false;" ';
			else
				$output .= 'onClick="ajaxmp_ref.send_http_request(\'GET\',\''.$onclick.'\',\'\',true);return false;" ';
		}

		$output .= "/>";
		return $output;
	}

	function button($value, $onclick)
	{
		$output = '<input type="submit" name="op" class="form-submit" value="'.$value.'" ';
		$output .= 'onClick="'.$onclick.'" />';
		return $output;
	}

	function file_upload($name, $size)
	{
		return '<input type="file" name="edit['. $name .']" id="edit-'.$name.'" size="'.$size.'" class="form-file" />';
	}
		
}
?>
