// common.js
// created the 09/12/05 by mickael ROYER

function print_time(time) 
{
	min = Math.floor(time/'60');
	sec = time % '60';
	if (sec<10)
		sec = '0'+sec
	return min+":"+sec;
}

/*
 * encode value before to send at the server
*/
function urlencode(str) {
  var output = new String(encodeURIComponent(str));
  output = output.replace(/'/g,"%27");
  return output;
}

/**
 * Returns true if an element has a specified class name
 */
function hasClass(node, className) {
  if (node.className == className) {
    return true;
  }
  var reg = new RegExp('(^| )'+ className +'($| )')
  if (reg.test(node.className)) {
    return true;
  }
  return false;
}

/**
 * Adds a class name to an element
 */
function addClass(node, className) {
  if (hasClass(node, className)) {
    return false;
  }
  node.className += ' '+ className;
  return true;
}

/**
 * Removes a class name from an element
 */
function removeClass(node, className) {
  if (!hasClass(node, className)) {
    return false;
  }
  node.className = eregReplace('(^| )'+ className , '', node.className);
  return true;
}

/**
 * Toggles a class name on or off for an element
 */
function toggleClass(node, className) {
  if (!removeClass(node, className) && !addClass(node, className)) {
    return false;
  }
  return true;
}

/**
 * Emulate PHP's ereg_replace function in javascript
 */
function eregReplace(search, replace, subject) {
  return subject.replace(new RegExp(search,'g'), replace);
}

/**
 * Wrapper around document.getElementById().
 */
function $(id) {
  return document.getElementById(id);
}

// find a value in a specific array and returns the index
function find_in_array()
{
	var args = find_in_array.arguments;
	if(!args.length) return -1;

	var haystack = typeof(args[0])=='object' ? args[0] : args.length>1 && typeof(args[1])=='object' ? args[1] : new Array();
	var needle = typeof(args[0])!='object' ? args[0] : args.length>1 && typeof(args[1])!='object' ? args[1] : '';
	var nocase = args.length==3 ? args[2] : false;

	if(!haystack.length) return -1;

	for(var i=0; i<haystack.length; i++)
		if(nocase && haystack[i].toLowerCase()==needle.toLowerCase())
			return i;
		else if(haystack[i]==needle)
			return i;

	return -1;
}

function create_div(content,class_name,id_value)
{
	var div = document.createElement('DIV');
	with (div)
	{
		className = class_name ? class_name : '';
		innerHTML = content; 
		if (id_value) id = id_value;
	}

	return div;
}
