// layer.js

var track_objects = new Array();

function track_layer(id, attributes)
{
	this.name = id;
  
	// create a new layer in the current document
	this.create = function(arg)
	{
		var l = (arg.x) ? arg.x : 0;
		var t = (arg.y) ? arg.y : 0;
		var w = arg.width;
		var h = arg.height;
		var z = arg.zindex;
		var vis = arg.vis;
		var parent = arg.parent;
		var obj;

		obj = document.createElement('DIV');
		with(obj)
		{
			id = this.name;
			with(style)
			{
				position = 'absolute';
				visibility = (vis) ? (vis==2) ? 'inherit' : 'visible' : 'hidden';
				left = l+'px';
				top = t+'px';
				if(w) width = w+'px';
				if(h) height = h+'px';
				if(z) zIndex = z;
			}
		}
      
		if(parent) parent.appendChild(obj);
		else document.body.appendChild(obj);

		this.elm = obj;
	};


	  // create new layer
	if(attributes!=null)
	{
		this.create(attributes);
		this.name = this.elm.id;
	}
	else  // just refer to the object
		this.elm = document.getElementById(id);

	if(!this.elm)
		return false;

	// ********* layer object properties *********
	this.css = this.elm.style;
	this.event = this.elm;
	this.width = this.elm.offsetWidth;
	this.height = this.elm.offsetHeight;
	this.x = parseInt(this.elm.offsetLeft);
	this.y = parseInt(this.elm.offsetTop);
	this.visible = (this.css.visibility=='visible' || this.css.visibility=='show' || this.css.visibility=='inherit') ? true : false;

	this.id = track_objects.length;
	this.obj = 'track_objects['+this.id+']';
	track_objects[this.id] = this;


	// ********* layer object methods *********

	// move the layer to a specific position
	this.move = function(x, y)
	{
		this.x = x;
		this.y = y;
		this.css.left = Math.round(this.x)+'px';
		this.css.top = Math.round(this.y)+'px';
	};

	// move the layer for a specific step
	this.shift = function(x,y)
	{
		x = Math.round(x*100)/100;
		y = Math.round(y*100)/100;
		this.move(this.x+x, this.y+y);
	};

	// change the layers width and height
	this.resize = function(w,h)
	{
		this.css.width  = w+'px';
		this.css.height = h+'px';
		this.width = w;
		this.height = h;
	};

	// cut the layer (top,width,height,left)
	this.clip = function(t,w,h,l)
	{
		this.css.clip='rect('+t+' '+w+' '+h+' '+l+')';
		this.clip_height = h;
		this.clip_width = w;
	};

	// show or hide the layer
	this.show = function(a)
	{
		if(a==1)
		{
			this.css.visibility = 'visible';
			this.visible = true;
		}
		else if(a==2)
		{
			this.css.visibility = 'inherit';
			this.visible = true;
		}
		else
		{
			this.css.visibility = 'hidden';
			this.visible = false;
		}
	};

	// write new content into a Layer
	this.write = function(cont)
	{
		this.elm.innerHTML = cont;
	};

	// set the given color to the layer background
	this.set_bgcolor = function(c)
	{
		if(!c || c=='#')
			c = 'transparent';

		this.css.backgroundColor = c;
	};

	// set the opacity of a layer to the given ammount (in %)
	this.set_opacity = function(v)
	{
		if(!bw.opacity)
			return;

		var op = v<=1 ? Math.round(v*100) : parseInt(v);

		if(bw.ie)
			this.css.filter = 'alpha(opacity:'+op+')';
		else if(bw.safari)
		{
			this.css.opacity = op/100;
			this.css.KhtmlOpacity = op/100;
		}
		else if(bw.mz)
			this.css.MozOpacity = op/100;
	};
}

// return the absolute position of an object within the document
function get_object_pos(obj)
{
	if(typeof(obj)=='string')
		obj = nex_get_object(obj);

	if(!obj) return {x:0, y:0};

	var iX = (bw.layers) ? obj.x : obj.offsetLeft;
	var iY = (bw.layers) ? obj.y : obj.offsetTop;

	if(bw.ie || bw.mz)
	{
		var elm = obj.offsetParent;
		while(elm && elm!=null)
		{
			iX += elm.offsetLeft;
			iY += elm.offsetTop;
			elm = elm.offsetParent;
		}
	}

	if(bw.mac && bw.ie5) iX += document.body.leftMargin;
	if(bw.mac && bw.ie5) iY += document.body.topMargin;

	return {x:iX, y:iY};
}
