/*
 * main.js
 */

// Constant
var CONTROL_KEY = 1;
var SHIFT_KEY = 2;
var CONTROL_SHIFT_KEY = 3;


var ajaxmp_ref;

function ajaxmp() 
{
	// messages variables
	this.message_time = 10000;
	this.messages = new Array();

	// User options
	this.request_timeout = 10000;
	this.dblclick_time = 400;
	this.search_time = 1000;
	this.enable_shortcut_keys = true;
	this.nav_type = false;

	// menu (volume, time and xfade) 
	this.bar_menu = '';
	this.volume = '0';
	this.time = '0';
	this.xfade = '0';

	// Intern parms
	this.current_track = -1;
	this.in_playlist = false;
	this.in_save_playlist = false;
	this.in_navigation = false;
	this.last_fileselected = false;
	this.commands = new Array();
	this.menu_bar = false;
	this.search_timeout = false;
	this.list_files = new Array();
	this.file_selection = new Array();

	// reference at the object
	ajaxmp_ref = this;
	this.ref = 'ajaxmp_ref';

	this.init = function()
	{
		// Initaite handle event
		document.oncontextmenu = function(){ return false; }
		document.onmousedown = function(){ return ajaxmp_ref.reset_click(); };
		document.onkeydown   = function(e){ return ajaxmp_ref.use_arrow_keys(e); };
		document.onkeypress   = function(e){ return ajaxmp_ref.use_arrow_keypress(e); };

		$('navigation').onmousedown = function(e){return ajaxmp_ref.click_on_navigation(e);};

		$('playlist').onmousedown = function(e){return ajaxmp_ref.click_on_playlist(e);};
		$('playlist').onmouseup = function(e){return ajaxmp_ref.add_pltrack(e);};

		// Initiate interactive search
		$('search_string').onkeyup = function(e){
			if (ajaxmp_ref.search_timeout)
				clearTimeout(ajaxmp_ref.search_timeout);

			ajaxmp_ref.search_timeout = setTimeout('ajaxmp_ref.send_search();', ajaxmp_ref.search_time);
			};
		$('search_type').onchange = function(e){ajaxmp_ref.send_search();};

		$('select_file_all').onmousedown = function(e){return ajaxmp_ref.select_files(e,'all',this);};
		$('select_file_none').onmousedown = function(e){return ajaxmp_ref.select_files(e,'none',this);};
		$('select_file_invert').onmousedown = function(e){return ajaxmp_ref.select_files(e,'invert',this);};

		// Init file commands
		this.commands['file-erase'] = function(e){
				e.cancelBubble = true;
				return ajaxmp_ref.navigation_delete_playlist();
				};
		this.commands['file-load'] = function(e){
				e.cancelBubble = true;
				return ajaxmp_ref.navigation_load_files();
				};
		// Init playlist commands
		this.commands['pl-clear'] = function(e){
				return ajaxmp_ref.playlist_clear(); };
		this.commands['pl-clearsel'] = function(e){
				return ajaxmp_ref.playlist_clear_selected(); };
		this.commands['pl-shuffle'] = function(e){
				ajaxmp_ref.send_http_request('GET','command.php?action=shuffle_playlist','',1);
				return false; };
		this.commands['pl-save'] = function(e){
				return ajaxmp_ref.print_save_playlist_block(); };

		// Init webradios commands
		this.commands['plweb-erase'] = function(e){
				return ajaxmp_ref.webradio_erase_all(); };
		this.commands['plweb-erasesel'] = function(e){
				return ajaxmp_ref.webradio_erase_selected(); };

		this.send_http_request('GET','command.php?action=init','',false);
	}

	this.enable_command = function()
	{
		var args = this.enable_command.arguments;
		if(!args.length) return -1;

		var obj;
		var enable = args[args.length-1];
		for(var n=0; n<args.length-1; n++)
		{
			obj = $(args[n]+"_command");
			if (enable)
			{
				obj.onmousedown = this.commands[args[n]]; 
				removeClass(obj,'disable');
			}
			else
			{
				obj.onmousedown = function(){return false;}; 
				addClass(obj,'disable');
			}
		}
	};

	this.reset_click = function()
	{
		this.in_playlist = false;
		this.in_navigation = false;
		this.clear_fileselection();
		this.clear_plselection();

		return true;
	};

	this.click_on_playlist = function(e)
	{
		if (!e)
			e = window.event;

		if (!this.in_playlist)
		{
			this.clear_fileselection();
			this.in_navigation = false;
			this.in_playlist = true;
		}

		e.cancelBubble = true;
		return true;
	};

	this.click_on_navigation = function(e)
	{
		if (!e)
			e = window.event;

		if (!this.in_navigation)
		{
			this.clear_plselection();
			this.in_playlist = false;
			this.in_navigation = true;
		}

		e.cancelBubble = true;
		return true;
	};

	this.use_arrow_keypress = function(e) 
	{
		var keyCode = document.layers ? e.which : document.all ? event.keyCode : document.getElementById ? e.keyCode : 0;
		var mod_key = this.get_modifier(e);
		var scroll_to = 0;

		if (this.in_playlist)
		{
			var frame = $('playlist');
			var last_selected = this.list_pltrack[Number(this.last_plselected)];
		}
		else if (this.in_navigation)
		{
			var frame = this.nav_frame;
			var last_selected = this.list_files[Number(this.last_fileselected)];
		}
		else {return true;}

		if (!last_selected) {return true;}

		if (keyCode == 40) 
		{ // down arrow key pressed
			var new_obj = last_selected.obj.nextSibling;
			while (new_obj && new_obj.nodeType != 1) {
				new_obj = new_obj.nextSibling;
			}
			if (!new_obj) return false;
			scroll_to = (Number(new_obj.offsetTop) + Number(new_obj.offsetHeight)) - Number(frame.offsetHeight);
		}
		else if (keyCode == 38) 
		{ // up arrow key pressed
			var new_obj = last_selected.obj.previousSibling;
			// Do not select navigation links
			if (new_obj && new_obj.id == 'link') {return false;}

			while (new_obj && new_obj.nodeType != 1) {
				new_obj = new_obj.previousSibling;
			}
			if (!new_obj) return false;
		 	scroll_to = new_obj.offsetTop;
		}
		// desactivate keys used with the keydown event
		else if (keyCode == 68 || keyCode == 13 || keyCode == 90 || keyCode == 88 || keyCode == 86 || keyCode == 67 || keyCode == 66)
		{
			return false;
		} 
		else {return true;}

		if (mod_key != CONTROL_KEY)
		{
			var obj_id = new String(new_obj.id);
			var id = parseInt(obj_id.substring(obj_id.lastIndexOf('-')+1));
			if (this.in_playlist)
        			this.select_pltrack(id,mod_key);
			else
        			this.select_file(id,mod_key);
		}

		if (((Number(new_obj.offsetTop)) < (Number(frame.scrollTop))) ||
		 	((Number(new_obj.offsetTop) + Number(new_obj.offsetHeight)) > (Number(frame.scrollTop) + Number(frame.offsetHeight)))) 
		{
			frame.scrollTop = scroll_to;
		}

		return false;
	};

	this.use_arrow_keys = function(e) 
	{
		// Do not activate control keys if 
		//	* we are in the navigation block (search or config part)
		//	* we try to enter a name to record the current playlist
		//	* the browser is opera (because control keys are in conflict with opera shortcut) 
		//	* user disable this option 
		if ((this.in_navigation && this.nav_selected != 'library')
			|| bw.opera 
			|| this.in_save_playlist == true
			|| this.enable_shortcut_keys == false) 
			return true;

		var keyCode = document.layers ? e.which : document.all ? event.keyCode : document.getElementById ? e.keyCode : 0;
		var mod_key = this.get_modifier(e);

		switch (keyCode)
		{
			case 68 :
			// "d" key pressed
			if (this.in_playlist)
				return this.playlist_clear();

			else if (this.in_navigation && this.nav_selected == 'library' && 
				this.nav_type == "playlist")
			{
				// delete selected playlists
				return this.navigation_delete_playlist(); 
			}
			else {return true;}
			break;

			case 13 :
			// "enter" key pressed
			if (this.in_playlist && this.pl_selection.length == 1)
			{
				this.send_http_request('GET','command.php?action=skipto&id='
					+this.pl_selection[0],'',true);
			}
			else {return true;}
			break;

			// Control key
			case 88 :
			// "x" key pressed
			this.send_http_request('GET','command.php?action=play','',true);
			break;

			case 86 :
			// "v" key pressed
			this.send_http_request('GET','command.php?action=stop','',true);
			break;

			case 67 :
			// "c" key pressed
			this.send_http_request('GET','command.php?action=pause','',true);
			break;

			case 66 :
			// "b" key pressed
			this.send_http_request('GET','command.php?action=next','',true);
			break;

			case 90 :
			// "z" key pressed
			this.send_http_request('GET','command.php?action=previous','',true);
			break;

			default :
			return true;
		}

		return false;
	};

	// lock/unlock interface
	this.set_busy = function(a)
	{
		if (a) 
		{
			$('loading').style.display = 'block';
			this.hide_message();
      		}
    		else if (!a && this.busy)
		{
			$('loading').style.display = 'none';
			this.hide_message();
		}

    		this.busy = a;

		var form_object = document.form;
    		if (form_object)
      			this.lock_form(form_object, a);

    		// clear pending timer
    		if (this.request_timer)
      			clearTimeout(this.request_timer);

		// set timer for requests
		if (a && this.request_timeout)
			this.request_timer = setTimeout(this.ref+'.request_timed_out()', this.request_timeout);
	}

	// lock/unlock form
  	this.lock_form = function(form_object, a)
  	{
		if (!form || !form.elements)
			return;

		var type;
		for (var n=0; n<form.elements.length; n++)
		{
			type = form.elements[n];
			if (type=='hidden')
				continue;

			form.elements[n].disabled = lock;
		}
  	};

	// called when a request timed out
	this.request_timed_out = function()
	{
		this.set_busy(false);
		this.display_message(this.messages['request_timeout'], 'error');
	};

/********************************************************/
	this.display_message = function(msg,type,hold)
	{
		var msg_obj = $('message');
		if (msg_obj)
		{
			var cont = msg;
  
			cont = '<div class="'+type+'">'+cont+'</div>';
			msg_obj.innerHTML = cont;
			msg_obj.style.display = 'block';
		}

		if (!hold)
			this.message_timer = setTimeout(this.ref+'.hide_message()', this.message_time);
	};

	this.hide_message = function()
	{
		$('message').style.display = 'none';
	};


	/********************************************************/
	/********************************************************/
	this.http_sockets = new Array();

	this.get_request_obj = function()
	{
		for (var n=0; n<this.http_sockets.length; n++) 
		{
			if (!this.http_sockets[n].busy)
				return this.http_sockets[n];
		}

		// create a new XMLHTTP object 
		var i = this.http_sockets.length;
		this.http_sockets[i] = new http_request();

		return this.http_sockets[i];
	};

	// send a request at the server
	this.send_http_request = function(type, url, parm, lock)
	{
		window.scrollTo('0','0');
		var request_obj = this.get_request_obj();

		// add timestamp to request url to avoid cacheing problems in Safari
		if (bw.safari)
			url += '&_ts='+(new Date().getTime());

		if (request_obj) 
		{
			if (lock)
				this.set_busy(true);

			request_obj.__lock = lock ? true : false;
			request_obj.onerror = function(o){ ajaxmp_ref.http_error(o); };
			request_obj.oncomplete = function(o){ ajaxmp_ref.http_response(o); };
			if (type == 'GET')
				request_obj.GET(url);
			else
				request_obj.POST(url,parm);
		}
	};
  
	this.http_error = function(request_obj)
	{
		alert('Error: '+request_obj.url);
    
		if (request_obj.__lock)
			this.set_busy(false);

		request_obj.reset();
		request_obj.__lock = false;
	};

	this.http_response = function(request_obj)
	{
		var ctype = request_obj.get_header('Content-Type');
		if (ctype)
			ctype = String(ctype).toLowerCase();

		if (request_obj.__lock)
			this.set_busy(false);

		//this.debug_console(request_obj.responseText);

		var xmldoc = request_obj.responseXML;
		if (xmldoc)
		{
			var rs = xmldoc.getElementsByTagName("block");
			if (rs)
			{
				for (var i=0; inner=rs.item(i); i++)
				{
				$(inner.getAttribute('id')).innerHTML = inner.firstChild.data;
				}
			}
			rs = xmldoc.getElementsByTagName("l10n").item(0);
			if (rs)
				this.update_messages(rs);

			rs = xmldoc.getElementsByTagName("playlist").item(0);
			if (rs)
				this.construct_playlist(rs);

			rs = xmldoc.getElementsByTagName("control").item(0);
			if (rs)
				this.update_control(rs);

			rs = xmldoc.getElementsByTagName("volume").item(0);
			if (rs)
				this.update_volume(rs);

			rs = xmldoc.getElementsByTagName("library").item(0);
			if (rs)
				this.construct_library(rs);

			rs = xmldoc.getElementsByTagName("search_result").item(0);
			if (rs)
				this.construct_search_result(rs);

			rs = xmldoc.getElementsByTagName("config").item(0);
			if (rs)
				this.load_config(rs);

			rs = xmldoc.getElementsByTagName("message").item(0);
			if (rs)
			{
				lock = false;
				if (rs.getAttribute('type') == 'error')
					lock = true;
				this.display_message(rs.firstChild.data,rs.getAttribute('type'),lock);
			}

			rs = xmldoc.getElementsByTagName("form_errors").item(0);
			if (rs)
				this.set_form_errors(rs);

			rs = xmldoc.getElementsByTagName('javascript').item(0);
			if (rs)
				eval(rs.firstChild.data);
		}
		else
			alert(request_obj.responseText); 
	};
/******************************************************/
/******* INTERNATIONALISATION PART ********************/
/******************************************************/
	this.update_messages = function(xml_l10n)
	{
		var msgs = xml_l10n.getElementsByTagName("l10n_msg");

		for (var i=0;msg=msgs.item(i);i++)
			this.messages[msg.getAttribute('name')] = msg.firstChild.data;
	};

/******************************************************/
/*********** PLAYLIST PART ****************************/
/******************************************************/
	this.print_save_playlist_block = function()
	{
		var obj = $('save_playlist');
		obj.style.display = 'block';
		// Initialise the save_playlist block position
		obj.style.left = (Number(window.innerWidth) - Number(obj.offsetWidth))/2 + 'px';
		obj.style.top = (Number(window.innerHeight) - Number(obj.offsetHeight))/2 + 'px';

		$('playlist_name').focus();
		this.in_save_playlist = true;

		return false;
	}

	this.cancel_save_playlist = function()
	{
		$('save_playlist').style.display = 'none';
		$('playlist_name').value = '';
		this.in_save_playlist = false;

		return false;
	}

	this.save_playlist = function(form_button)
	{
		if (this.list_pltrack.length >= 1)
		{
			var form = form_button.form;
			if (form.playlist_name.value.length)
			{
				var playlist = new Array();
				playlist[0] = form.playlist_name.value;
				this.send_http_request('POST','command.php?action=save_playlist',playlist,true);	
				// clear the field and hide the block
				$('save_playlist').style.display = 'none';
				form.playlist_name.value = '';
				this.in_save_playlist = false;
			}
			else
				this.display_message(this.messages['playlist_noname_warning'], 'warning',false);
		}
		else
			this.display_message(this.messages['playlist_notrack_warning'], 'warning',false);

		return false;
	};

	this.construct_playlist = function(playlist_obj)
	{
		var tracks = playlist_obj.getElementsByTagName("track");
		var webradios = playlist_obj.getAttribute('webradios');
		var playlist = $("playlist_content");
		
		// Init variables
		this.list_pltrack = new Array();
		this.pl_selection = new Array
		// Clear the playlist
		// Use elegant way to do this (DOM method) in order to becompatible with konqueror
		while(playlist.hasChildNodes() == true)
			playlist.removeChild(playlist.childNodes[0]);

		// Enable commands clear and shuffle if we are tracks in the playlist
		var enable = tracks.item(0) ? true : false;
		if (!webradios)
			this.enable_command('pl-clear','pl-clearsel','pl-shuffle','pl-save',enable);
		else
			this.enable_command('plweb-erase','plweb-erasesel',enable);

		for (var i=0; track = tracks.item(i); i++)
			this.construct_track(playlist,track,webradios);
	};

	this.construct_track = function(playlist,track,webradios)
	{
		// Obtain informations on the track
		this.num = '';
		var title = 'unknown title'
		var id_tag = track.getElementsByTagName('num').item(0);
		var title_tag = track.getElementsByTagName('title').item(0);
		if (id_tag && id_tag.firstChild)
			this.num = id_tag.firstChild.data;
		if (title_tag && title_tag.firstChild)
			title = title_tag.firstChild.data;

		if (!webradios)
		{
			var artist = 'unknown artist'
			var album = 'unknown album'
			var time = '0';

			var album_tag = track.getElementsByTagName('album').item(0);
			var artist_tag = track.getElementsByTagName('artist').item(0)
			var time_tag = track.getElementsByTagName('time').item(0);
			if (artist_tag && artist_tag.firstChild)
				artist = artist_tag.firstChild.data;
			if (album_tag && album_tag.firstChild)
				album = album_tag.firstChild.data;
			if (time_tag && time_tag.firstChild)
				time = time_tag.firstChild.data;

			var value = [title,artist,album,print_time(time)];
			var value_cls = ['title','artist','album','time'];
		}
		else
		{
			// Load the correct navigation part if necessary
			this.nav_select('webradios');

			var value = [title];
			var value_cls = ['title'];
		}

		// construct the row
		var obj = document.createElement('TR');	
		with (obj)
		{
			id = 'track-'+this.num;
			className = "playlist_track";
		}
		// construct the col
		for (c in value)
		{
			var c_obj = document.createElement('TD');
			c_obj.innerHTML = value[c];
			addClass(c_obj,value_cls[c]);
			obj.appendChild(c_obj);
		}

		playlist.appendChild(obj);
		this.init_pltrack(obj,this.num);
		return;
	};

	this.init_pltrack = function(track,id)
	{
		this.list_pltrack[id] = {id:track.id,obj:track,
					plIndex:id,clicked:false};

		if (document.all)
		        track.onselectstart = function() { return false; };
		track.onmouseup = function(e){ return ajaxmp_ref.pltrack_click(e,this,id); };
		track.onmousedown = function(e){ return ajaxmp_ref.pltrack_draw(e,this,id); };
	};

	/*********************************************************/
	/********* event handling methods for playlist   *********/
	/*********************************************************/
	this.add_pltrack = function(e)
	{
		if (this.drag_active)
			this.navigation_load_files();

		return false;
	};

	this.pltrack_draw = function(e,track,id)
	{

		this.in_plselection_before = this.in_plselection(id) ? id : -1;

		// selects currently unselected row
		if (!this.in_plselection(id))
		{
			var mod_key = this.get_modifier(e);
			this.select_pltrack(id,mod_key);
		}

		if (this.pl_selection.length)
		{
			this.drag_start = true;
			this.selection = this.pl_selection;
			this.list_rows = this.list_pltrack;
			document.onmousemove = function(e){ return ajaxmp_ref.drag_mouse_move(e); };
			document.onmouseup = function(e){ return ajaxmp_ref.drag_mouse_up(e); };
		}

		return false;
	}

	this.pltrack_click = function(e,track,id)
	{
		if (this.drag_active && this.pl_selection.length == 1 && this.pl_selection[0] != id)
		{
			var url = 'command.php?action=move_pltrack&id='+this.pl_selection[0]+
					'&new_id='+id;
			this.send_http_request('GET',url,'',true);
		}

		// unselects currently selected row
		if (!this.drag_active && this.in_plselection_before==id) 
		{
			var mod_key = this.get_modifier(e);
			this.select_pltrack(id,mod_key);
		}
		this.drag_start = false;
		this.in_plselection_before = -1;

		//row was double clicked
		if (this.list_pltrack[id] && this.list_pltrack[id].clicked)
		{
			this.send_http_request('GET','command.php?action=skipto&id='+id,'',true);
			return false;
		}

		this.list_pltrack[id].clicked = true;
		setTimeout(this.ref+'.list_pltrack['+id+'].clicked=false;', this.dblclick_time);

		return false;
	};

	/*********************************************************/
	/************* Actions for the playlist ******************/
	/*********************************************************/
	this.playlist_clear = function()
	{
		this.send_http_request('GET','command.php?action=clear_playlist','',true);
		return false;
	};

	this.playlist_clear_selected = function()
	{
		if (this.pl_selection.length != 0)	
		{
			var files = new Array();
			for(var i=0; i<this.pl_selection.length; i++)
				files[i] = this.pl_selection[i];

			this.send_http_request('POST','command.php?action=remove_playlist',files,true);
		}
		return false;
	};

	/*********************************************************/

	this.highlight_pltrack = function(id,multiple)
	{
		if (this.list_pltrack[id] && !multiple)
		{
			this.clear_plselection();
			this.pl_selection[0] = id;
			addClass(this.list_pltrack[id].obj,'selected');
		}
		else if (this.list_pltrack[id])
		{
			if (!this.in_plselection(id))  // select track
			{
				this.pl_selection[this.pl_selection.length] = id;
				addClass(this.list_pltrack[id].obj, 'selected');
			}
			else  // unselect track
			{
				var p = find_in_array(id, this.pl_selection);
				var a_pre = this.pl_selection.slice(0, p);
				var a_post = this.pl_selection.slice(p+1, this.pl_selection.length);
				this.pl_selection = a_pre.concat(a_post);
				removeClass(this.list_pltrack[id].obj, 'selected');
			}
		}
	};

	this.select_pltrack = function(id,mod_key)
	{
		if (!mod_key) 
		{
	        	this.shift_start = id;
	        	this.highlight_pltrack(id, false);
	        } 
		else 
		{
	        	switch (mod_key) 
			{
	        		case SHIFT_KEY: {
	        			this.shift_pltrack(id,false);
	        			break; }
	        		case CONTROL_KEY: {
	        			this.shift_start = id;
	        			this.highlight_pltrack(id, true);
	        			break; }
	        		case CONTROL_SHIFT_KEY: {
	        			this.shift_pltrack(id,true);
	        			break; }
	        		default: {
	        			this.highlight_pltrack(id, false);
	        			break; }
	        	}
	        }
	        this.last_plselected = id;
	};

	this.shift_pltrack = function(id,control)
	{
		var from_plIndex = Number(this.list_pltrack[this.shift_start].plIndex);
		var to_plIndex = Number(this.list_pltrack[id].plIndex);

		var i = Math.min(from_plIndex,to_plIndex);
		var j = Math.max(from_plIndex,to_plIndex);

		// iterate through the entire playlist
		for (var n in this.list_pltrack) 
		{
			if ((this.list_pltrack[n].plIndex >= i) && (this.list_pltrack[n].plIndex <= j)) 
			{
	        		if (!this.in_plselection(n))
	        			this.highlight_pltrack(n, true);
			}
			else 
			{
	        		if  (this.in_plselection(n) && !control)
	        			this.highlight_pltrack(n, true);
	        	}
	        }
	};

	// check if given id is part of the current selection
	this.in_plselection = function(id)
	{
		for(var n in this.pl_selection)
			if (this.pl_selection[n]==id)
				return true;

		return false;
	};

	this.clear_plselection = function()
	{
		for(var n=0; n<this.pl_selection.length; n++)
			if (this.list_pltrack[this.pl_selection[n]])
				removeClass(this.list_pltrack[this.pl_selection[n]].obj,'selected');

		this.pl_selection = new Array();
	};

/*******************************************************
************* Navigation Part **************************
*******************************************************/
	this.nav_select = function(type)
	{
		if (this.nav_selected != type)
		{
			if (this.nav_selected)
				removeClass($(this.nav_selected+'_menu'),'active');

			this.nav_selected = type;
			addClass($(type+'_menu'),'active');
			$('search_form').style.display = (type == 'search' ? 'block':'none'); 
                        $('addwebradio_form').style.display = (type == 'webradios' ? 'block':'none');
			$('library_submenu').style.display = (type == 'library' ? 'block':'none'); 
		}
	};

	this.nav_library = function(type)
	{
		// Reload the current playlist if we left the webradios part
		if (this.nav_selected == 'webradios')
			this.send_http_request('GET','command.php?action=load_current_playlist','',false);

		if (!type && !this.nav_type)
			type = 'directory';
		else if (!type)
			type = this.nav_type;

		if (type == 'directory')
		{
			var url = 'command.php?action=list_dir';
			if (this.nav_listdir_path)
				url += '&path='+urlencode(this.nav_listdir_path);
		}
		else if (type == 'tag')
			var url = 'command.php?action=tag_navigation';
		else if (type == 'playlist')
			var url = 'command.php?action=playlist_dir';


		this.send_http_request('GET', url,'',true);
		return false;
	};

	this.nav_construct_path = function(path)
	{
		  var tmp = path.split("/");
		  var link_obj = document.createElement('DIV');
		  link_obj.id = "link";
		  // construct links
		  for (var i=-1; i < (tmp.length); i++) 
		  {
		  	var tmp_path = '';
		  	for (var j=0; j<(i); j++)
		  		tmp_path += tmp[j]+"/";
		  	tmp_path += (i == -1 ? '' : tmp[i]);

			var obj = document.createElement('A');
			with (obj)
			{
				innerHTML = tmp[i] ? tmp[i] : 'Root';
				className = 'link';
				id = tmp_path ? tmp_path : 'root_link';
			}
			obj.onclick = function(e)
				{
					var url = 'command.php?action=list_dir';
					if (this.id !='root_link')
						url += '&path='+urlencode(this.id);

					ajaxmp_ref.send_http_request('GET',url,'',true); 
					return false;
				}
			link_obj.appendChild(obj);
		  }
		  this.nav_frame.appendChild(link_obj);
		  // Update the interne reference
		  this.nav_listdir_path = path;
	};

	this.construct_library = function(library_obj)
	{
		var type = library_obj.getAttribute('type'); 
		var files = library_obj.getElementsByTagName("track_node");

	// Initialisation
		this.nav_frame = $("navigation_content");
		this.nav_select('library');
		if (this.nav_type != type)
		{
			if (this.nav_type)
				removeClass($(this.nav_type+'_menu'),'active');
			this.nav_type = type;
			addClass($(type+'_menu'),'active');
			$(type+'_menu').blur();
		}
		this.enable_command('file-erase','file-load',false);

		// Variables
		this.list_files = new Array();
		this.file_selection = new Array();
		this.last_fileselected = false;

		if (type == 'directory')
		{
			this.nav_frame.innerHTML = '';
			var height = Number($('nav_menu').offsetHeight) + Number($('library_submenu').offsetHeight);
			var path = library_obj.getAttribute('path');
			if (path)
			{
				this.nav_construct_path(path);
				height += Number($('link').offsetHeight) + 10;
			}
			else
		  		this.nav_listdir_path = '';

			var file_content = this.construct_file_content('directory',height+'px');
			this.nav_frame.appendChild(file_content);
			this.nav_frame = file_content;
		}
		else if (type == 'tag')
		{
			if (!$('panels'))
			{
				this.nav_frame.innerHTML = '';
				this.construct_panel(library_obj);
			}
			else if (library_obj.getElementsByTagName('albums').item(0))
				this.update_albums_panel(library_obj.getElementsByTagName('albums').item(0));	

			this.nav_frame = $('file_content');
			this.nav_frame.innerHTML = '';
		}
		else if (type == 'playlist')
		{
			this.nav_frame.innerHTML = '';
			var height = Number($('nav_menu').offsetHeight) + Number($('library_submenu').offsetHeight);
			var file_content = this.construct_file_content('playlist',height+'px');
			this.nav_frame.appendChild(file_content);
			this.nav_frame = file_content;
		}

		// Construct list of files
		for (var i=0; file = files.item(i); i++)
			this.construct_file(file,i);

		if (!this.list_files.length && this.nav_type == 'playlist')
			this.nav_frame.innerHTML = this.messages['no_playlist_found'];
	};

	this.construct_file = function(file,num)
	{
		// Extract info
		var type = file.getAttribute('type'); 
		var path = file.firstChild.data; 
		var name = path.substring(path.lastIndexOf('/')+1); 
		// construct the row
		var obj = document.createElement('DIV');	
		with (obj)
		{
			innerHTML = name;
			id = 'file-'+num;
			className = type;
		}

		this.nav_frame.appendChild(obj);
		this.init_file(obj,num,path,type);
	};

	this.init_file = function(file,id,path,type)
	{
		this.list_files[id] = {id:file.id,obj:file,
					path:path,plIndex:id,
					type:type,clicked:false};

		if (document.all)
		        file.onselectstart = function() { return false; };
		file.onmouseup = function(e){ return ajaxmp_ref.file_click(e,this,id); };
		file.onmousedown = function(e){ return ajaxmp_ref.file_draw(e,this,id); };
	};

	this.construct_file_content = function(class_name,top_pos)
	{
			var file_content = document.createElement('DIV');
			with (file_content)
			{
				id = 'file_content';
				className = class_name;
				style.top = top_pos;
			}

			return file_content;
	};

	/*********************************************************/
	/**** action methods for navigation library   ************/
	/*********************************************************/
	this.navigation_delete_playlist = function()
	{
		if (this.file_selection && this.file_selection.length >= 1)
		{
			// Confirm the erase of selected playlist
			var rs = window.confirm(this.messages['confirm_plerase'])

			if (rs)
			{
				var files = new Array();
				for(var i=0; i<this.file_selection.length; i++)
					files[i] = this.list_files[this.file_selection[i]].path;

				this.send_http_request('POST','command.php?action=delete_playlist',files,true);
				this.enable_command('file-load','file-erase',false);
			}
		}

		return false;
	};

	this.navigation_load_files = function()
	{
		if (this.file_selection.length >= 1)
		{
			var files = new Array();
			for(var i=0; i<this.file_selection.length; i++)
				files[i] = this.list_files[this.file_selection[i]].path;

			if ((this.nav_selected == 'library' && this.nav_type != 'playlist') ||
					this.nav_selected == 'search')
				var url = 'command.php?action=add_playlist';

			else if (this.nav_selected == 'library' && this.nav_type == 'playlist')
				var url = 'command.php?action=load_playlist';

			else {return false;}

			this.send_http_request('POST',url,files,true);
		}

		return false;
	};

	/*********************************************************/
	/** event handling methods for navigation list_dir   *****/
	/*********************************************************/
	this.file_draw = function(e,file,id)
	{
		this.in_fileselection_before = this.in_fileselection(id) ? id : -1;

		if (this.nav_selected == 'search' && !this.file_selection.length)
			$('search_string').blur();
		// selects currently unselected row
		if (!this.in_fileselection(id))
		{
			var mod_key = this.get_modifier(e);
			this.select_file(id,mod_key);
		}

		if (this.file_selection.length)
		{
			this.selection = this.file_selection;
			this.list_rows = this.list_files;
			this.drag_start = true;
			document.onmousemove = function(e){ return ajaxmp_ref.drag_mouse_move(e); };
			document.onmouseup = function(e){ return ajaxmp_ref.drag_mouse_up(e); };
		}

		return false;
	};

	this.file_click = function(e,file,id)
	{
		// unselects currently selected row
		if (!this.drag_active && this.in_fileselection_before==id)
		{
			var mod_key = this.get_modifier(e);
			this.select_file(id,mod_key);
		}

		this.drag_start = false;
		this.in_fileselection_before = -1;

		//row was double clicked
		if (this.list_files[id] && this.list_files[id].clicked)
		{

			if (this.list_files[id].type == 'playlist')
			{
				// load selected playlist
				var files = new Array();
				files[0] = this.list_files[id].path;
				this.send_http_request('POST','command.php?action=load_playlist',files,true);
			}
			else
			{
				if (this.list_files[id].type == 'directory')
					this.send_http_request('GET','command.php?action=list_dir&path='+
						urlencode(this.list_files[id].path),'',true);
			}

			return false;
		}
		

		this.list_files[id].clicked = true;
		setTimeout(this.ref+'.unclicked_file('+id+');', this.dblclick_time);

		return true;
	};

	this.unclicked_file = function(id)
	{
		if (this.list_files[id])
			this.list_files[id].clicked = false;
	}

	/*********************************************************/
	this.highlight_file = function(id,multiple)
	{
		if (this.list_files[id] && !multiple)
		{
			this.clear_fileselection();
			this.file_selection[0] = id;
			addClass(this.list_files[id].obj,'selected');

			this.enable_command('file-load',true);
			if (this.nav_type == 'playlist')
				this.enable_command('file-erase',true);
		}
		else if (this.list_files[id])
		{
			if (!this.in_fileselection(id))  // select track
			{
				this.file_selection[this.file_selection.length] = id;
				addClass(this.list_files[id].obj, 'selected');

				this.enable_command('file-load',true);
				if (this.nav_type == 'playlist')
					this.enable_command('file-erase',true);
			}
			else  // unselect track
			{
				var p = find_in_array(id, this.file_selection);
				var a_pre = this.file_selection.slice(0, p);
				var a_post = this.file_selection.slice(p+1, this.file_selection.length);
				this.file_selection = a_pre.concat(a_post);
				removeClass(this.list_files[id].obj, 'selected');

				if (!this.file_selection.length)
					this.enable_command('file-load','file-erase',false);
			}
		}
	};

	this.select_file = function(id,mod_key)
	{
		if (!mod_key) 
		{
	        	this.fshift_start = id;
	        	this.highlight_file(id, false);
	        } 
		else 
		{
	        	switch (mod_key) 
			{
	        		case SHIFT_KEY: {
	        			this.shift_file(id,false);
	        			break; }
	        		case CONTROL_KEY: {
	        			this.fshift_start = id;
	        			this.highlight_file(id, true);
	        			break; }
	        		case CONTROL_SHIFT_KEY: {
	        			this.shift_file(id,true);
	        			break; }
	        		default: {
	        			this.highlight_file(id, false);
	        			break; }
	        	}
	        }
	        this.last_fileselected = id;
	};

	this.shift_file = function(id,control)
	{
		var from_plIndex = Number(this.list_files[this.fshift_start].plIndex);
		var to_plIndex = Number(this.list_files[id].plIndex);

		var i = Math.min(from_plIndex,to_plIndex);
		var j = Math.max(from_plIndex,to_plIndex);

		// iterate through the entire playlist
		for (var n in this.list_files) 
		{
			if ((this.list_files[n].plIndex >= i) && (this.list_files[n].plIndex <= j)) 
			{
	        		if (!this.in_fileselection(n))
	        			this.highlight_file(n, true);
			}
			else 
			{
	        		if  (this.in_fileselection(n) && !control)
	        			this.highlight_file(n, true);
	        	}
	        }
	};

	// check if given id is part of the current selection
	this.in_fileselection = function(id)
	{
		for(var n in this.file_selection)
			if (this.file_selection[n]==id)
				return true;

		return false;
	};

	this.clear_fileselection = function()
	{
		for(var n=0; n<this.file_selection.length; n++)
			if (this.list_files[this.file_selection[n]])
				removeClass(this.list_files[this.file_selection[n]].obj,'selected');

		this.file_selection = new Array();

		// Disable command
		this.enable_command('file-load','file-erase',false);
	};

	this.select_all_file = function()
	{
		// First clear the current selection
		this.clear_fileselection();

		for(var n=0; n<this.list_files.length; n++)
			this.highlight_file(this.list_files[n].plIndex,true);
	};

	this.invert_fileselection = function()
	{
		for(var n=0; n<this.list_files.length; n++)
			this.highlight_file(this.list_files[n].plIndex,true);
	};

	this.select_files = function(e,type,obj)
	{
		this.click_on_navigation(e);
		switch (type)
		{
			case 'all' :
			this.select_all_file();
			break;

			case 'none' :
			this.clear_fileselection();
			break;

			case 'invert' :
			this.invert_fileselection();
			break;
		}
		obj.blur();

		return false;
	};

	/*********************************************************/
	/************** Navigation by Tag   **********************/
	/*********************************************************/
	this.construct_panel = function(library_object)
	{
		// Create the form
		var panel_obj = document.createElement('DIV');
		panel_obj.id = 'panels';

		// Insert artists panel
		var artists_obj = library_object.getElementsByTagName('artists').item(0);
		var panel_artist = document.createElement('DIV');
		panel_artist.id = 'artists_panel';
		panel_artist.className = 'panel';
		this.construct_panel_options(panel_artist,panel_artist.id,artists_obj.getElementsByTagName('node'));

		panel_obj.appendChild(panel_artist);

		// Insert albums panel
		var albums_obj = library_object.getElementsByTagName('albums').item(0);
		var panel_album = document.createElement('DIV');
		panel_album.id = 'albums_panel';
		panel_album.className = 'panel';
		this.construct_panel_options(panel_album,panel_album.id,albums_obj.getElementsByTagName('node'));

		panel_obj.appendChild(panel_album);

		// Insert panel in the navigation content
		this.nav_frame.appendChild(panel_obj);

		// Prepare file content
		var height = Number($('panels').offsetHeight) + Number($('nav_menu').offsetHeight) + Number($('library_submenu').offsetHeight) + 9;
		var file_content = this.construct_file_content('tag',height+'px');
		this.nav_frame.appendChild(file_content);
	};

	this.construct_panel_options = function(panel,panel_name,options_obj)
	{
		for (var i=0;value = options_obj.item(i);i++)
		{
			var option = document.createElement('DIV');
			with (option)
			{
				id = panel_name+'-'+i;
				if (!value.firstChild)
					innerHTML = '';
				else
					innerHTML = value.firstChild.data;
				option.className = 'panel_element';
			}
			option.onclick = function(e) 
			{
				return ajaxmp_ref.select_panel_option(this); 
			};
			panel.appendChild(option);
		}
	};

	this.update_albums_panel = function(albums_obj)
	{
		var panel = $('albums_panel');
		// First, clear the content of this panel
		panel.innerHTML = '';

		this.construct_panel_options(panel,'albums_panel',albums_obj.getElementsByTagName('node'));
	};

	this.select_panel_option = function(option_obj)
	{
		if (!option_obj.id.search(/artists_panel/g))
		{
			return this.select_artist(option_obj);
		}
		else if (!option_obj.id.search(/albums_panel/g))
		{
			return this.select_album(option_obj);
		}

	};

	this.select_artist = function(option_obj)
	{
		if (this.selected_artist)
			removeClass(this.selected_artist,'selected');
		this.selected_artist = option_obj;
		addClass(this.selected_artist,'selected');

		var reg = new RegExp('.-0');
		var url = 'command.php?action=get_artist';
		url += reg.test(option_obj.id) ? '' : '&artist='+urlencode(this.selected_artist.innerHTML);
		this.send_http_request('GET',url,'',true); 

		return false;
	};

	this.select_album = function(option_obj)
	{
		if (this.selected_album)
			removeClass(this.selected_album,'selected');
		this.selected_album = option_obj;
		addClass(this.selected_album,'selected');

		var reg = new RegExp('.-0');
		var url = 'command.php?action=get_album';
		url += reg.test(option_obj.id) ? '' : '&album='+urlencode(this.selected_album.innerHTML);
		if (this.selected_artist && !reg.test(this.selected_artist.id))
			url += '&artist='+urlencode(this.selected_artist.innerHTML);
		this.send_http_request('GET',url,'',true); 

		return false;
	};

	/*********************************************************/
	/************** Navigation search part   *****************/
	/*********************************************************/
	this.nav_search = function()
	{
		// Reload the current playlist if we left the webradios part
		if (this.nav_selected == 'webradios')
			this.send_http_request('GET','command.php?action=load_current_playlist','',false);

		this.nav_frame = $('navigation_content');
		if (this.nav_selected != 'search')
		{
			this.nav_select('search');
			// Erase the navigation content
			this.nav_frame.innerHTML = '';

			// Obtain the result of the last search
			this.send_search();
		}

		return false;
	};
	
	this.send_search = function()
	{
		var form = document.search_form_name;
		if (form.elements[0].value.length)
		{
			var send_obj = new Array();
			// Prepare info to send
			send_obj['search_string'] = form.elements[0].value;
			send_obj['search_type'] = form.elements[1].value;

			this.send_http_request('POST','command.php?action=search',send_obj,true);
			return false;
		}
	};

	this.clear_search = function(form)
	{
		// Erase the navigation content
		this.nav_frame.innerHTML = '';
		// Erase the textfield content
		form.elements[0].value = '';

		return false;
	};

	this.construct_search_result = function(search_obj)
	{
		var files = search_obj.getElementsByTagName("track_node");
		// Clear the content
		$("navigation_content").innerHTML = '';
		// Construct_file_content
		var height = Number($('nav_menu').offsetHeight)+Number($('search_form').offsetHeight)+5;
		var file_content = this.construct_file_content('search',height+'px');
		$("navigation_content").appendChild(file_content);
		this.nav_frame = file_content;
		// Variables
		this.list_files = new Array();
		this.file_selection = new Array();

		for (var i=0; file = files.item(i); i++)
			this.construct_file(file,i);
	};

	/*********************************************************/
	/************** Navigation webradios part ****************/
	/*********************************************************/
	this.nav_webradios = function()
	{
                this.send_http_request('GET','command.php?action=webradios_dir','',true);

		this.nav_frame = $('navigation_content');
		if (this.nav_selected != 'webradios')
		{
			this.nav_select('webradios');
			// Erase the navigation content
			this.nav_frame.innerHTML = '';
		}

		return false;
	};

	this.add_webradio = function(form)
	{
		if (form.elements[0].value.length)
		{
			var send_obj = new Array();
			send_obj['webradio_url'] = form.elements[0].value;

			this.send_http_request('POST','command.php?action=add_webradio',send_obj,true);
			form.elements[0].value = '';
			return false;
		}
	};

	/*********************************************************/
	/************* Actions for webradios *********************/
	/*********************************************************/
	this.webradio_erase_all = function()
	{
		this.send_http_request('GET','command.php?action=clear_webradio','',true);
		return false;
	};

	this.webradio_erase_selected = function()
	{
		if (this.pl_selection.length != 0)	
		{
			var files = new Array();
			for(var i=0; i<this.pl_selection.length; i++)
				files[i] = this.pl_selection[i];

			this.send_http_request('POST','command.php?action=remove_webradio',files,true);
		}
		return false;
	};

	/*********************************************************/
	/*********** Navigation configuration part   *************/
	/*********************************************************/
	this.nav_config = function()
	{
		// Reload the current playlist if we left the webradios part
		if (this.nav_selected == 'webradios')
			this.send_http_request('GET','command.php?action=load_current_playlist','',false);

		this.nav_select('config');
		this.send_http_request('GET','command.php?action=config','',true);

		return false;
	};

	this.load_config = function(config_obj)
	{
		// Update Refresh
		var refresh = config_obj.getElementsByTagName("refresh").item(0);
		if (refresh)
		{
			if (this.interval_event)
			{
				clearInterval(this.interval_event);
				this.interval_event = false;
			}

			if (refresh.firstChild.data > 0)
				this.interval_event = setInterval( "ajaxmp_ref.send_http_request('GET','command.php?action=get_control','',false)",
					refresh.firstChild.data*'1000');
		}

		// Update others variable
		this.message_time = Number(config_obj.getElementsByTagName("message_time").item(0).firstChild.data);
		this.request_timeout = Number(config_obj.getElementsByTagName("request_timeout").item(0).firstChild.data);
		this.dblclick_time = Number(config_obj.getElementsByTagName("dbl_click").item(0).firstChild.data);
		this.enable_shortcut_keys = config_obj.getElementsByTagName("enable_shortcut_keys").item(0).firstChild.data;
	};

	this.send_config = function(form)
	{
		var config_parms = new Array();
		var elt = '';
		
		for (var i=0;elt = form.elements[i]; i++) 
		{
			switch (elt.type) 
			{
				case 'checkbox' :
				config_parms[elt.name] =  (elt.checked ? urlencode(elt.value) : 0);
				break;

				default :
				config_parms[elt.name] =  urlencode(elt.value);
			}
		}

		this.send_http_request('POST','command.php?action=record_config',config_parms,true);

		return false;
	};


/******************************************************/
/*********** CONTROL PART *****************************/
/******************************************************/
	this.update_control = function(control_obj)
	{
		/* update the state */
		var state = control_obj.getElementsByTagName("state")[0].firstChild.data;
		if (state)
		{
			switch (state) 
			{
				case 'play' :
				document.play.src='images/play_hi.png';
				document.stop.src='images/stop.png';
				document.pause.src='images/pause.png';
				break;

				case 'stop' :
				document.stop.src='images/stop_hi.png';
				document.play.src='images/play.png';
				document.pause.src='images/pause.png';
				break;
				case 'pause' :
				document.pause.src='images/pause_hi.png';
				document.stop.src='images/stop.png';
				document.play.src='images/play.png';
				break;
			}
		}

		// update the current track
		var track = control_obj.getElementsByTagName("current_track");
		if (track.item(0)) 
		{
			// Update the current track in the playlist 
			var cur_id = parseInt(track.item(0).getElementsByTagName('num').item(0).firstChild.data);

			if (this.current_track != -1 && cur_id != this.current_track && 
					this.list_pltrack[this.current_track])
				removeClass(this.list_pltrack[this.current_track].obj,'current');

			addClass(this.list_pltrack[cur_id].obj,'current');
			this.current_track = cur_id;

			var cur_pos = control_obj.getElementsByTagName("current_track_position").item(0).firstChild.data;
			var cur_len = control_obj.getElementsByTagName("current_track_length").item(0).firstChild.data;

			this.time = Math.floor(cur_pos*'100'/cur_len);
			if (this.menu_bar == 'time')
				this.updatebar(this.time);

			var title = track.item(0).getElementsByTagName('title').
				item(0).firstChild.data +' ('+print_time(cur_pos)+'/'+print_time(cur_len)+')';

			var artist_item = track.item(0).getElementsByTagName('artist').item(0);
			var artist = artist_item ? artist_item.firstChild.data : false;

			var album_item = track.item(0).getElementsByTagName('album').item(0);
			var album = album_item ? album_item.firstChild.data : false;

			$("current_track").innerHTML = '';
			$("current_track").appendChild(create_div(title,'title'));
			if (artist) $("current_track").appendChild(create_div(artist,'artist'));
			if (album) $("current_track").appendChild(create_div(album,'album'));

			

		}
		else 
		{
			// Update the current track in the playlist 
			if (this.current_track != -1 && this.list_pltrack[this.current_track])
				 removeClass(this.list_pltrack[this.current_track].obj,'current');
			this.current_track = -1;

			document.getElementById("current_track").innerHTML = this.messages['no_track_playing'];
		}

		/* update the mode if necesary*/
		if ($('repeat') && $('random'))
		{
			if ( control_obj.getElementsByTagName("repeat").item(0).firstChild.data == '1')
				addClass($('repeat'),'active');
			else
				removeClass($('repeat'),'active');
			if ( control_obj.getElementsByTagName("random").item(0).firstChild.data == '1')
				addClass($('random'),'active');
			else
				removeClass($('random'),'active');
		}
	}

	this.update_volume = function(volume_obj)
	{
		this.volume = volume_obj.firstChild.data;
		if (this.menu_bar == 'volume')
			this.updatebar(this.volume);
	}

	this.set_xfade = function(form_button)
	{
		var value = form_button.parentNode.elements[0].value;
		this.send_http_request('GET','command.php?action=set_xfade&value='+value,'',true);

		return false;
	}

/***************************************************
************** Menu Bar ****************************
***************************************************/
	this.setbar = function(link, type)
	{
		if (this.menu_bar == type)
		{
			$('bar').style.display = 'none';
			this.menu_bar = '';
		}
		else
		{
			var value = (type == 'volume' ? this.volume : this.time);	
			this.updatebar(value);
			$('bar').style.display = 'block';
			this.menu_bar = type;
		}
		toggleClass(link,'active');
		var other = (type == 'volume' ? 'time_id' : 'volume_id'); 
		removeClass($(other),'active');
		link.blur();
	};

	this.updatebar = function(value)
	{
		var image = '';
		for (var i = 1; i < 101; i++) 
		{
			image = (i < value ? 'light' : 'dark');	
			$('bar-'+i).src = 'images/slider'+image+'.png';
		}
	};

	this.set_valuebar = function(value)
	{
		if (this.menu_bar == 'volume')
			this.send_http_request('GET','command.php?action=set_volume&vol='+value,'',true);
		else
			this.send_http_request('GET','command.php?action=set_track_position&value='+value,'',true);
	};

	this.down_valuebar = function()
	{
		var value = (this.menu_bar == 'volume' ? parseFloat(this.volume) - 5 : parseFloat(this.time) - 5);
		this.set_valuebar(value);
	};

	this.up_valuebar = function()
	{
		var value = (this.menu_bar == 'volume' ? parseFloat(this.volume) + 5 : parseFloat(this.time) + 5);
		this.set_valuebar(value);
	};

	/************************************************************/
	/**************** Drag and Drop method **********************/
	/************************************************************/
	this.drag_mouse_move = function(e)
	{
		if (this.drag_start)
	 	{
	 		if (!this.draglayer)
	 		this.draglayer = new track_layer('dirobject', {x:0, y:0, width:300, vis:0, zindex:2000});

         		// get title of selected songs
         		var titles = '';
	 		for(var n=0; n<this.selection.length; n++)
	 		{
	 			if (n>12)  // only show 12 lines
	 			{
	 				titles += '...';
	 				break;
	 			}

				// Obtain just the title
         			if (this.list_rows[this.selection[n]].obj)
         			{
         				var obj = this.list_rows[this.selection[n]].obj;
					// Playlist
					if (obj.childNodes[0].nodeName=='TD')
					{
						var title = new String(obj.childNodes[0].firstChild.data);
						titles += (title.length > 50 ? title.substring(0,50)+'...' : title)+'<br/>';
					}
					// Navigation
					else if (obj.nodeName == 'DIV')
					{
						var title = new String(obj.innerHTML);
						titles += (title.length > 50 ? title.substring(0,50)+'...' : title)+'<br/>';
					}
         			}
         		}

         		this.draglayer.write(titles);
	 		this.draglayer.show(1);
	 	}

	 	var pos = this.get_mouse_pos(e);
	 	this.draglayer.move(pos.x+20, pos.y-5);

         	this.drag_start = false;
         	this.drag_active = true;

         	return false;
         };

	this.drag_mouse_up = function()
        {
		document.onmousemove = null;

        	if (this.draglayer && this.draglayer.visible)
			this.draglayer.show(0);

		this.drag_active = false;

		return false;
	};

/************************************************
	HELPER Method
*************************************************/
	// check if Shift-key is pressed on event
	this.check_shiftkey = function(e)
	{
		if(!e && window.event)
			e = window.event;

		if(bw.linux && bw.ns4 && e.modifiers)
			return true;
		else if((bw.ns4 && e.modifiers & Event.SHIFT_MASK) || (e && e.shiftKey))
			return true;
		else
			return false;
	};

	// check if Ctrl-key is pressed on event
	this.check_ctrlkey = function(e)
	{
		if(!e && window.event)
			e = window.event;

		if(bw.linux && bw.ns4 && e.modifiers)
        		return true;
		else if (bw.mac)
			return this.check_shiftkey(e);
		else if((bw.ns4 && e.modifiers & Event.CTRL_MASK) || (e && e.ctrlKey))
			return true;
		else
			return false;
	};

	// returns modifier key (constants defined at top of file)
	this.get_modifier = function(e)
	{
		var opcode = 0;
		if (e = e || window.event)
		{
			opcode += (e.ctrlKey && CONTROL_KEY) + (e.shiftKey && SHIFT_KEY);
			return opcode;
		}
		if (e.cancelBubble)
		{
			e.cancelBubble = true;
			e.returnValue = false;
		}
		else if (e.preventDefault)
			e.preventDefault();
	};

	// Return the mouse position
	this.get_mouse_pos = function(e)
	{
		if(!e) e = window.event;
		var mX = (e.pageX) ? e.pageX : e.clientX;
		var mY = (e.pageY) ? e.pageY : e.clientY;

		if(document.body && document.all)
		{
			mX += document.body.scrollLeft;
			mY += document.body.scrollTop;
		}

		return { x:mX, y:mY };
	};
/***************************************************/

	this.set_form_errors = function(form_object)
	{
		var form = $(form_object.getAttribute('name'));
		this.clear_form_errors(form);

		var rs = '';
		var errors_object = form_object.getElementsByTagName('error');

		for (var i=0; error = errors_object.item(i); i++)
		{
			addClass($(error.getAttribute('id')),'error');
			rs += '<li>'+error.firstChild.data+'</li>';
		}

		this.display_message("<ul>" + rs + "</ul>\n",'error',true);
	};

	this.clear_form_errors = function(form)
	{
		for (var j=0; el = form.elements[j]; j++)
			removeClass(el,'error');
	};

/***************************************************/
	this.debug_console = function(msg)
	{
		var debug_obj = $('debug');
		if (!debug_obj)
		{
			// Create the debug block
			debug_obj = document.createElement('DIV');
			debug_obj.id = "debug";
			$('header').appendChild(debug_obj);

			// Create the textarea
			var form = document.createElement('FORM');
			var textarea = document.createElement('TEXTAREA');
			textarea.id = 'debug_content';
			form.appendChild(textarea);
			debug_obj.appendChild(form);
		}

		$('debug_content').value = msg;
		debug_obj.style.display = 'block';
	};
}

if (bw.xmlhttp_test()) 
{
	window.onload = function(e)
	{
		var _ajaxmp = new ajaxmp();
		_ajaxmp.init();
	};
}
else
	alert('Your browser don\'t support AJAX request, try an other browser to use ajaxMP'); 
