<?php
/*
  Copyright (c) 2003, 2004 Alfa21 Outsourcing
  Created by Jacobo Tarrio <jtarrio [at] alfa21.com>
  with contributions from Gabor Hojtsy <goba [at] php.net>
  Licensed under the terms of the GNU General Public License
*/

  set_time_limit(0);
  if (!defined("STDERR")) {
    define("STDERR", fopen("php://stderr", "w"));
  }
  
// Set the list of files
  $files = array('../command.php','../login.php','../include/auth.php',
  		'../include/block.php','../include/cls/class.config.php',
		'../include/cls/class.auth.php','../index.php',
		'../include/cls/form.php');

  $strings = array();

// Set the output file name
  $filename = 'locale.php';
  $argv = $GLOBALS['argv'];
  array_shift ($argv);
  if (count($argv) == 1) {
   $filename = $argv[0];
  }

  foreach ($files as $file) {
    $code = file_get_contents($file);
    
    // Extract raw tokens
    $raw_tokens = token_get_all($code);

    // Remove whitespace and HTML
    $tokens = array();
    $lineno = 1;
    foreach ($raw_tokens as $tok) {
      if ((!is_array($tok)) || (($tok[0] != T_WHITESPACE) && ($tok[0] != T_INLINE_HTML))) {
        if (is_array($tok)) {
          $tok[] = $lineno;
        }
        $tokens[] = $tok;
      }
      if (is_array($tok)) {
        $lineno += count(split("\n", $tok[1])) - 1;
      } else {
        $lineno += count(split("\n", $tok)) - 1;
      }
    }
    
    find_t_calls($tokens, $file);
  }

  $output = "<?php\n"."$"."locale = array();\n";

  $test_array = array();
  foreach ($strings as $str) {
    if (in_array($str,$test_array))
      continue;
    $output .= "$"."locale[\"".$str."\"] = \"\";\n";
    $test_array[] = $str;
  }
  $output .= "?>";

// Write file
    $fp = fopen($filename, 'w');
    fwrite($fp,$output);
    fclose($fp);


  function format_quoted_string($str) {
    $quo = substr($str, 0, 1);
    $str = substr($str, 1, -1);
    if ($quo == '"') {
      $str = stripcslashes($str);
    } else {
      $str = strtr($str, array("\\'" => "'", "\\\\" => "\\"));
    }
    return addcslashes($str, "\0..\37\\\"");
  }
  
  function marker_error($file, $line, $marker, $tokens) {
    fwrite(STDERR, "Invalid marker content in $file:$line\n* $marker(");
    array_shift($tokens); array_shift($tokens);
    $par = 1;
    while (count($tokens) && $par) {
      if (is_array($tokens[0])) {
        fwrite(STDERR, $tokens[0][1]);
      } else {
        fwrite(STDERR, $tokens[0]);
        if ($tokens[0] == "(") {
          $par++;
        }
        if ($tokens[0] == ")") {
          $par--;
        }
      }
      array_shift($tokens);
    }
    fwrite(STDERR, "\n\n");
  }
  
  /*
    Detect all occurances of one of these sequences:
      T_STRING("t") + "(" + T_CONSTANT_ENCAPSED_STRING + ")"
      T_STRING("t") + "(" + T_CONSTANT_ENCAPSED_STRING + ","
  */
  function find_t_calls($tokens, $file) {
    global $strings;
    
    while (count($tokens) > 3) {
      
      list($ctok, $par, $mid, $rig) = $tokens;
      if (!is_array($ctok)) {
        array_shift($tokens);
        continue;
      }
      list($type, $string, $line) = $ctok;
      
      if (($type == T_STRING) && ($string == "t") && ($par == "(")) {
        
        if (in_array($rig, array(")", ","))
            && (is_array($mid) && ($mid[0] == T_CONSTANT_ENCAPSED_STRING))) {

          $strings[] = format_quoted_string($mid[1]);
        }
        
        // t() found, but inside is something which is not a string literal
        else {
          marker_error($file, $line, "t", $tokens);
        }
      }
      array_shift($tokens);
    }
  }
